use serde::{Deserialize, Serialize};
use std::sync::OnceLock;

//全局配置
pub static EMU_CONFIG: OnceLock<AppConfig> = OnceLock::new();

#[derive(Debug, Serialize, Deserialize)]
pub struct AppConfig {
    pub emu: EmuConfig,
}

#[derive(Serialize, Deserialize, Debug)]
pub struct EmuConfig {
    pub ver: String,
    pub pcs: PcsConfig,
    pub ems: EmsConfig,
    pub bms: BmsConfig,
}

#[derive(Serialize, Deserialize, Debug)]
pub struct PcsConfig {}
#[derive(Serialize, Deserialize, Debug)]
pub struct EmsConfig {
    //读取间隔, 单位ms
    pub read_interval: u64,
}
#[derive(Serialize, Deserialize, Debug)]
pub struct BmsConfig {}
