use crate::ems::{Consumer, Producer, Service};
use crate::internal::utils;
use log::info;

pub struct Pcs {
    pub id: String,
    pub producer: Producer,
    pub consumer: Consumer,
}

impl Pcs {
    /// 初始化PCS
    pub async fn new(producer: Producer, consumer: Consumer) -> Self {
        let id = utils::generate_random_str(12);
        utils::log::init_log("inpower_iot_mgc_rs::ems::pcs::*", "logs/pcs.log").await;
        info!("PCS [{}] 初始化成功", id);
        Pcs {
            id,
            producer,
            consumer,
        }
    }
}

#[async_trait::async_trait]
impl Service for Pcs {
    async fn serve(&mut self) {}
}
